#include <windows.h>
#include <stdio.h>
#include <shlobj.h>
#include <shobjidl.h>
#include <shlguid.h>
#include <ctype.h>
#include <tchar.h>
#include <vector>
#include "resource.h"
#include "get_vc_cmd.h"

extern vector<VC_CMD> vc_cmd;	//	R}hvvgւ̃V[gJbg̃pX̔z

TCHAR path[MAX_PATH];	//	X^[gj[ւ̃pX

//	X^[gj[Visual C++̃R}hvvg̃ob`t@Cւ̃pX擾
int chk_vc_cmd(void);

//	X^[gj[Visual C++̃R}hvvgւ̃V[gJbg擾
int find_vc(IShellLink *m_pShellLink, IPersistFile *m_pPersistFile, TCHAR* pass);

//	Visual C++̃tH_[̏ꍇAtrueԂ
bool vc_dir_chk(TCHAR* str);

//	Visual C++̃tH_[̃c[oꍇtrueԂ
bool vc_tool_dir_chk(TCHAR* str);

//	R}h쐬
TCHAR* make_cmd_str(TCHAR* cmd, int cmdMax, int num, TCHAR* add_cmd, TCHAR* build);

//	V[gJbg̃N̎擾
TCHAR* link_target(IShellLink *m_pShellLink, IPersistFile *m_pPersistFile, TCHAR* pass, TCHAR* link);

//	Visual C++̃o[Wԍ擾
int get_vc_ver(TCHAR* str);

//	R}hCIvVrbg擾
int get_vc_bit(TCHAR* str);

//	R}hŎw肵ϐ̓WJ
void arg_rep(VC_CMD& vc_cmd, TCHAR* cmd, TCHAR* parse);

//	R}hCIvVob`t@C𒊏o
TCHAR* cmd_opt2bat(TCHAR* src);

//	X^[gj[Visual C++̃R}hvvgւ̃V[gJbg擾

int chk_vc_cmd(void){
	unsigned int n;

	if (FAILED(CoInitialize(NULL))){	//	COM̏@STAiVOXbhAp[ggj
		MessageBox(0, _TEXT("COM̏Ɏs܂"), _TEXT("G["), MB_OK);
		return -1;
	}
	IShellLink		*m_pShellLink = NULL;
	IPersistFile	*m_pPersistFile = NULL;
	//	IShellLinkIuWFNg쐬
	if (CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER, IID_IShellLink, (LPVOID *)&m_pShellLink) == S_OK){
		//	IPersistFileC^[tF[X̍쐬
		if (m_pShellLink->QueryInterface(IID_IPersistFile, (LPVOID *)&m_pPersistFile) == S_OK){
			SHGetSpecialFolderPath(NULL, ::path, CSIDL_COMMON_STARTMENU, 0);
			find_vc(m_pShellLink, m_pPersistFile, ::path);	//	V[gJbg̈ꗗ쐬
			TCHAR link[MAX_PATH];
			for (n = 0; n<vc_cmd.size(); n++){
#ifdef _UNICODE
				if (m_pPersistFile->Load((LPCOLESTR)vc_cmd[n].fpass, STGM_READ) == S_OK){
#else
				WCHAR wfpass[MAX_PATH];
				MultiByteToWideChar(932, 0, vc_cmd[n].fpass, -1, wfpass, sizeof(wfpass) / sizeof(TCHAR));
				if (m_pPersistFile->Load((LPCOLESTR)wfpass, STGM_READ) == S_OK){
#endif
					if (m_pShellLink->Resolve(NULL, 0) == NOERROR){	//	NɃt@CȂꍇ̓G[
						m_pShellLink->GetPath(link, sizeof(link) / sizeof(TCHAR), NULL, SLGP_UNCPRIORITY);	//	N擾
						TCHAR opt[MAX_PATH];	//	V[gJbg̃N
						m_pShellLink->GetArguments(opt, MAX_PATH);

						vc_cmd[n].cmd = _tcsdup(link);
						vc_cmd[n].opt = _tcsdup(opt);
						vc_cmd[n].ver = get_vc_ver(vc_cmd[n].spass);
						vc_cmd[n].bit = get_vc_bit(vc_cmd[n].opt);
					}else{
						m_pShellLink->GetPath(link, sizeof(link) / sizeof(TCHAR), NULL, SLGP_UNCPRIORITY);	//	N擾
						vc_cmd[n].cmd = 0;
						vc_cmd[n].opt = 0;
					}
				}else{
					vc_cmd[n].cmd = 0;
					vc_cmd[n].opt = 0;
				}
			}
			m_pShellLink->Release();	//	IShellLinkIuWFNg̉
			m_pPersistFile->Release();	//	IPersistFileC^[tF[X̉
		}
		CoUninitialize();	//	COM̉
	}
	return 0;
}

//	X^[gj[Visual C++̃R}hvvgւ̃V[gJbg擾
int find_vc(IShellLink *m_pShellLink, IPersistFile *m_pPersistFile, TCHAR* pass){
	WIN32_FIND_DATA FindFileData;
	HANDLE hFind;
	TCHAR find_pass[MAX_PATH];
	int num = 0;	//	t@C

	int len = (int)_tcslen(pass) + 1;
	_stprintf_s(find_pass, sizeof(find_pass) / sizeof(TCHAR), _TEXT("%s\\*.*"), pass);	//	TufBNǧ
	hFind = FindFirstFile(find_pass, &FindFileData);
	if (hFind != INVALID_HANDLE_VALUE){
		do{
			if ((FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)){	//	fBNg̏ꍇ
				if (_tcscmp(FindFileData.cFileName, _TEXT("..")) && _tcscmp(FindFileData.cFileName, _TEXT("."))){	//	efBNg͖
					TCHAR prog_pass[MAX_PATH];	//	vOtH_[̃pX
					_stprintf_s(prog_pass, sizeof(prog_pass) / sizeof(TCHAR), _TEXT("%s\\%s\\*.*"), pass, FindFileData.cFileName);
#if 1
					WIN32_FIND_DATA prog_FindFileData;
					HANDLE prog_hFind;
					prog_hFind = FindFirstFile(prog_pass, &prog_FindFileData);
					if (prog_hFind != INVALID_HANDLE_VALUE){
						do{
							if ((prog_FindFileData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)){	//	fBNg̏ꍇ
								if (_tcscmp(prog_FindFileData.cFileName, _TEXT("..")) && _tcscmp(prog_FindFileData.cFileName, _TEXT("."))){	//	efBNg͖
									if (vc_dir_chk(prog_FindFileData.cFileName) == true){	//	Visual Studio 2013 & Microsoft Visual Studio 2008
#if 2
										TCHAR tool_pass[MAX_PATH];
										_stprintf_s(tool_pass, sizeof(tool_pass) / sizeof(TCHAR), _TEXT("%s\\%s\\%s\\*.*"), pass, FindFileData.cFileName, prog_FindFileData.cFileName);
										WIN32_FIND_DATA tool_FindFileData;
										HANDLE tool_hFind;
										tool_hFind = FindFirstFile(tool_pass, &tool_FindFileData);
										if (tool_hFind != INVALID_HANDLE_VALUE){
											do{
												if (1){
													if (_tcsstr(tool_FindFileData.cFileName, _TEXT("vvg"))){	//R}h vvg
														_stprintf_s(tool_pass, sizeof(tool_pass) / sizeof(TCHAR), _TEXT("%s\\%s\\%s\\%s"), pass, FindFileData.cFileName, prog_FindFileData.cFileName, tool_FindFileData.cFileName);
														VC_CMD t;
														t.fpass = _tcsdup(tool_pass);
														t.spass = _tcsdup(tool_FindFileData.cFileName);
														vc_cmd.push_back(t);
													}else
														if (vc_tool_dir_chk(tool_FindFileData.cFileName) == true){
#if 3
															TCHAR cmd_pass[MAX_PATH];
															TCHAR short_pass[MAX_PATH];
															bool short_cut;
															if (_tcsstr(tool_FindFileData.cFileName, _TEXT(".lnk"))){
																_stprintf_s(short_pass, sizeof(short_pass) / sizeof(TCHAR), _TEXT("%s\\%s\\%s\\%s"), pass, FindFileData.cFileName, prog_FindFileData.cFileName, tool_FindFileData.cFileName);
																link_target(m_pShellLink, m_pPersistFile, short_pass, cmd_pass);
																_tcscpy_s(short_pass, sizeof(short_pass) / sizeof(TCHAR), cmd_pass);
																_tcscat_s(cmd_pass, sizeof(cmd_pass) / sizeof(TCHAR), _TEXT("\\*.lnk"));
																short_cut = true;
															}else{
																_stprintf_s(cmd_pass, sizeof(cmd_pass) / sizeof(TCHAR), _TEXT("%s\\%s\\%s\\%s\\*.lnk"), pass, FindFileData.cFileName, prog_FindFileData.cFileName, tool_FindFileData.cFileName);
																short_cut = false;
															}
															WIN32_FIND_DATA cmd_FindFileData;
															HANDLE cmd_hFind;
															cmd_hFind = FindFirstFile(cmd_pass, &cmd_FindFileData);
															if (cmd_hFind != INVALID_HANDLE_VALUE){
																do{
																	if (_tcsstr(cmd_FindFileData.cFileName, _TEXT("vvg"))){	//R}h vvg
																		TCHAR full_pass[MAX_PATH];
																		if (short_cut == true){
																			_stprintf_s(full_pass, sizeof(full_pass) / sizeof(TCHAR), _TEXT("%s\\%s"), short_pass, cmd_FindFileData.cFileName);
																		}else
																			_stprintf_s(full_pass, sizeof(full_pass) / sizeof(TCHAR), _TEXT("%s\\%s\\%s\\%s\\%s"), pass, FindFileData.cFileName, prog_FindFileData.cFileName, tool_FindFileData.cFileName, cmd_FindFileData.cFileName);
																		VC_CMD t;
																		t.fpass = _tcsdup(full_pass);
																		t.spass = _tcsdup(cmd_FindFileData.cFileName);
																		vc_cmd.push_back(t);
																	}
																} while (FindNextFile(cmd_hFind, &cmd_FindFileData));
															}
#endif	//	3
														}
												}
											} while (FindNextFile(tool_hFind, &tool_FindFileData));

										}
#endif	//	2
									}
								}
							}
						} while (FindNextFile(prog_hFind, &prog_FindFileData));

					}
				}
#endif
			}
		} while (FindNextFile(hFind, &FindFileData));
	}
	FindClose(hFind);
	return num;
}

//	Visual C++̃tH_[̏ꍇAtrueԂ

bool vc_dir_chk(TCHAR* str){
	if (_tcsstr(str, _TEXT("Visual Studio")))
		return true;
	if (_tcsstr(str, _TEXT("Visual C++")))
		return true;
	return false;
}

//	Visual C++̃tH_[̃c[oꍇtrueԂ

bool vc_tool_dir_chk(TCHAR* str){
	if (_tcsstr(str, _TEXT("Tools")))
		return true;
	if (_tcsstr(str, _TEXT("c[")))	//Visual Studio c[
		return true;
	return false;
}

//	V[gJbg̃N̎擾

TCHAR* link_target(IShellLink *m_pShellLink, IPersistFile *m_pPersistFile, TCHAR* pass, TCHAR* link){
#ifdef _UNICODE
	if (m_pPersistFile->Load((LPCOLESTR)pass, STGM_READ) == S_OK){
#else
	WCHAR wfpass[MAX_PATH];
	MultiByteToWideChar(932, 0, pass, -1, wfpass, sizeof(wfpass) / sizeof(TCHAR));
	if (m_pPersistFile->Load((LPCOLESTR)wfpass, STGM_READ) == S_OK){
#endif
		if (m_pShellLink->Resolve(NULL, 0) == NOERROR){	//	NɃt@CȂꍇ̓G[bZ[W\
			m_pShellLink->GetPath(link, MAX_PATH, NULL, SLGP_UNCPRIORITY);	//	N擾
			return link;
		}
	}
	return 0;
}

//	Visual C++̃o[Wԍ擾

int get_vc_ver(TCHAR* str){
	TCHAR* p = str;
	TCHAR v[16];
	int n = 0;
	bool f = false;
	while (1){
		if (_istdigit(*p)){	//	
			v[n++] = *p;
			f = true;
		}else{
			if (f == true){
				if (n){
					v[n] = _T('\0');
				}
				if (n == 4){
					return _ttoi(v);

				}
				n = 0;
			}
			f = false;
		}
		if (*p == 0)
			break;
		++p;
	}
	return 0;
}

//	R}hCIvVrbg擾

int get_vc_bit(TCHAR* str){
	if (_tcsstr(str, _TEXT("vcvarsall.bat")) == 0)
		return 0;
	if (_tcsstr(str, _TEXT("amd64")))
		return 64;
	else
		return 86;
}
